Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asmbkg.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asmbkg.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asmbkg.F90	(revision 10986)
@@ -82,5 +82,8 @@
          !
          IF( .NOT. llok ) THEN
-            IF(lwp) WRITE(numout,*) ' Setting up assimilation background file '// TRIM( c_asmbkg )
+            IF(lwp) THEN
+               WRITE(numout,*) ' Setting up assimilation background file '// TRIM( c_asmbkg )
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             !                                      ! Define the output file        
@@ -90,5 +93,8 @@
                zdate = REAL( ndastp )
                IF( ln_zdftke ) THEN                   ! read turbulent kinetic energy ( en )
-                  IF(lwp) WRITE(numout,*) ' Reading TKE (en) from restart...'
+                  IF(lwp) THEN
+                     WRITE(numout,*) ' Reading TKE (en) from restart...'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   CALL tke_rst( nit000, 'READ' )
                ENDIF
@@ -120,5 +126,8 @@
          !
          IF( .NOT. llok ) THEN
-            IF(lwp) WRITE(numout,*) ' Setting up assimilation background file '// TRIM( c_asmdin )
+            IF(lwp) THEN
+               WRITE(numout,*) ' Setting up assimilation background file '// TRIM( c_asmdin )
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             !                                      ! Define the output file        
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asminc.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asminc.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ASM/asminc.F90	(revision 10986)
@@ -173,4 +173,5 @@
          WRITE(numout,*) '      Logical switch for ensuring that the sa > salfixmin      ln_salfix = ', ln_salfix
          WRITE(numout,*) '      Minimum salinity after applying the increments           salfixmin = ', salfixmin
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -209,4 +210,5 @@
          WRITE(numout,*) '       ditiaustr_date = ', ditiaustr_date
          WRITE(numout,*) '       ditiaufin_date = ', ditiaufin_date
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -311,4 +313,5 @@
              WRITE(numout,*) '         Time-integrated weight = ', ztotwgt
              WRITE(numout,*) '         ==================================='
+             IF(lflush) CALL FLUSH(numout)
           ENDIF
          
@@ -347,4 +350,5 @@
             WRITE(numout,*) 'asm_inc_init : Assimilation increments valid between dates ', z_inc_dateb,' and ', z_inc_datef
             WRITE(numout,*) '~~~~~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          !
@@ -462,4 +466,5 @@
             WRITE(numout,*) '   ==>>>  Assimilation background state valid at : ', zdate_bkg
             WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          !
@@ -491,5 +496,8 @@
       ENDIF
       !
-      IF(lwp) WRITE(numout,*) '   ==>>>   Euler time step switch is ', neuler
+      IF(lwp) THEN
+         WRITE(numout,*) '   ==>>>   Euler time step switch is ', neuler
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       IF( lk_asminc ) THEN                            !==  data assimilation  ==!
@@ -542,4 +550,5 @@
                WRITE(numout,*) 'tra_asm_inc : Tracer IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             !
@@ -657,4 +666,5 @@
                WRITE(numout,*) 'dyn_asm_inc : Dynamics IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             !
@@ -728,4 +738,5 @@
                   &  kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             !
@@ -845,4 +856,5 @@
                WRITE(numout,*) 'seaice_asm_inc : sea ice conc IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdydta.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdydta.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdydta.F90	(revision 10986)
@@ -449,8 +449,11 @@
       !!---------------------------------------------------------------------------
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'bdy_dta_ini : initialization of data at the open boundaries'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*) ''
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'bdy_dta_ini : initialization of data at the open boundaries'
+         WRITE(numout,*) '~~~~~~~~~~'
+         WRITE(numout,*) ''
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       ! Set nn_dta
@@ -485,5 +488,8 @@
          ENDIF
 #endif               
-         IF(lwp) WRITE(numout,*) 'Maximum number of files to open =', nb_bdy_fld(jbdy)
+         IF(lwp) THEN
+            WRITE(numout,*) 'Maximum number of files to open =', nb_bdy_fld(jbdy)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       END DO            
 
@@ -532,5 +538,8 @@
 
                IF( dta%ll_ssh ) THEN 
-                  if(lwp) write(numout,*) '++++++ reading in ssh field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in ssh field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_ssh
@@ -543,5 +552,8 @@
 
                IF( dta%ll_u2d .and. .not. ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in u2d field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in u2d field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u2d
@@ -554,5 +566,8 @@
 
                IF( dta%ll_v2d .and. .not. ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in v2d field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in v2d field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_v2d
@@ -572,5 +587,8 @@
 
                IF( dta%ll_u3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in u3d field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in u3d field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u3d
@@ -583,5 +601,8 @@
 
                IF( dta%ll_v3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in v3d field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in v3d field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_v3d
@@ -599,5 +620,8 @@
 
                IF( dta%ll_tem ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in tem field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in tem field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_tem
@@ -609,5 +633,8 @@
 
                IF( dta%ll_sal ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in sal field'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ reading in sal field'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   blf_i(jfld) = bn_sal
@@ -732,8 +759,12 @@
             write(numout,*) '++++++ dta%ll_tem = ',dta%ll_tem
             write(numout,*) '++++++ dta%ll_sal = ',dta%ll_sal
+            IF(lflush) CALL FLUSH(numout)
          endif
 
          IF ( nn_dyn2d_dta(jbdy) == 0 .or. nn_dyn2d_dta(jbdy) == 2 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%ssh/u2d/u3d allocated space'
+            IF(lwp) THEN
+               write(numout,*) '++++++ dta%ssh/u2d/u3d allocated space'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             IF( dta%ll_ssh ) ALLOCATE( dta%ssh(nblen(1)) )
             IF( dta%ll_u2d ) ALLOCATE( dta%u2d(nblen(2)) )
@@ -742,5 +773,8 @@
          IF ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) THEN
             IF( dta%ll_ssh ) THEN
-               if(lwp) write(numout,*) '++++++ dta%ssh pointing to fnow'
+               IF(lwp) THEN
+                  write(numout,*) '++++++ dta%ssh pointing to fnow'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                jfld = jfld + 1
                dta%ssh => bf(jfld)%fnow(:,1,1)
@@ -748,8 +782,14 @@
             IF ( dta%ll_u2d ) THEN
                IF ( ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ dta%u2d allocated space'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ dta%u2d allocated space'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   ALLOCATE( dta%u2d(nblen(2)) )
                ELSE
-                  if(lwp) write(numout,*) '++++++ dta%u2d pointing to fnow'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ dta%u2d pointing to fnow'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   dta%u2d => bf(jfld)%fnow(:,1,1)
@@ -758,8 +798,14 @@
             IF ( dta%ll_v2d ) THEN
                IF ( ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ dta%v2d allocated space'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ dta%v2d allocated space'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   ALLOCATE( dta%v2d(nblen(3)) )
                ELSE
-                  if(lwp) write(numout,*) '++++++ dta%v2d pointing to fnow'
+                  IF(lwp) THEN
+                     write(numout,*) '++++++ dta%v2d pointing to fnow'
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   jfld = jfld + 1
                   dta%v2d => bf(jfld)%fnow(:,1,1)
@@ -769,5 +815,8 @@
 
          IF ( nn_dyn3d_dta(jbdy) == 0 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%u3d/v3d allocated space'
+            IF(lwp) THEN
+               write(numout,*) '++++++ dta%u3d/v3d allocated space'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             IF( dta%ll_u3d ) ALLOCATE( dta_bdy(jbdy)%u3d(nblen(2),jpk) )
             IF( dta%ll_v3d ) ALLOCATE( dta_bdy(jbdy)%v3d(nblen(3),jpk) )
@@ -776,10 +825,16 @@
            &  ( ln_full_vel_array(jbdy) .and. ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) ) ) THEN
             IF ( dta%ll_u3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
-               if(lwp) write(numout,*) '++++++ dta%u3d pointing to fnow'
+               IF(lwp) THEN
+                  write(numout,*) '++++++ dta%u3d pointing to fnow'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                jfld = jfld + 1
                dta_bdy(jbdy)%u3d => bf(jfld)%fnow(:,1,:)
             ENDIF
             IF ( dta%ll_v3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
-               if(lwp) write(numout,*) '++++++ dta%v3d pointing to fnow'
+               IF(lwp) THEN
+                  write(numout,*) '++++++ dta%v3d pointing to fnow'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                jfld = jfld + 1
                dta_bdy(jbdy)%v3d => bf(jfld)%fnow(:,1,:)
@@ -788,15 +843,24 @@
 
          IF( nn_tra_dta(jbdy) == 0 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%tem/sal allocated space'
+            IF(lwp) THEN
+               write(numout,*) '++++++ dta%tem/sal allocated space'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             IF( dta%ll_tem ) ALLOCATE( dta_bdy(jbdy)%tem(nblen(1),jpk) )
             IF( dta%ll_sal ) ALLOCATE( dta_bdy(jbdy)%sal(nblen(1),jpk) )
          ELSE
             IF( dta%ll_tem ) THEN
-               if(lwp) write(numout,*) '++++++ dta%tem pointing to fnow'
+               IF(lwp) THEN
+                  write(numout,*) '++++++ dta%tem pointing to fnow'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                jfld = jfld + 1
                dta_bdy(jbdy)%tem => bf(jfld)%fnow(:,1,:)
             ENDIF
             IF( dta%ll_sal ) THEN 
-               if(lwp) write(numout,*) '++++++ dta%sal pointing to fnow'
+               IF(lwp) THEN
+                  write(numout,*) '++++++ dta%sal pointing to fnow'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                jfld = jfld + 1
                dta_bdy(jbdy)%sal => bf(jfld)%fnow(:,1,:)
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyini.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyini.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyini.F90	(revision 10986)
@@ -91,7 +91,10 @@
       ! -----------------------------------------
       IF ( ln_bdy ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'bdy_init : initialization of open boundaries'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'bdy_init : initialization of open boundaries'
+            WRITE(numout,*) '~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          ! Open boundaries definition (arrays and masks)
@@ -105,7 +108,10 @@
          !
       ELSE
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'bdy_init : open boundaries not used (ln_bdy = F)'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'bdy_init : open boundaries not used (ln_bdy = F)'
+            WRITE(numout,*) '~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
       ENDIF
@@ -403,4 +409,6 @@
         ENDIF
      ENDIF
+
+     IF(lflush .AND. lwp) CALL FLUSH(numout)
 
       ! -------------------------------------------------
@@ -568,7 +576,10 @@
                !
                ibr_max = MAXVAL( nbrdta(:,igrd,ib_bdy) )
-               IF(lwp) WRITE(numout,*)
-               IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
-               IF(lwp) WRITE(numout,*) ' nn_rimwidth from namelist is ', nn_rimwidth(ib_bdy)
+               IF(lwp) THEN
+                  WRITE(numout,*)
+                  WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
+                  WRITE(numout,*) ' nn_rimwidth from namelist is ', nn_rimwidth(ib_bdy)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                IF (ibr_max < nn_rimwidth(ib_bdy))   &
                      CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file',cn_coords_file(ib_bdy) )
@@ -1205,5 +1216,8 @@
                IF( i_offset == 1 .and. zefl + zwfl == 2 ) THEN
                   icount = icount + 1
-                  IF(lwp) WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+                  IF(lwp) THEN
+                     WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                ELSE
                   idx_bdy(ib_bdy)%flagu(ib,igrd) = -zefl + zwfl
@@ -1237,5 +1251,8 @@
                ! This error check only works if you are using the bdyXmask arrays
                IF( j_offset == 1 .and. znfl + zsfl == 2 ) THEN
-                  IF(lwp) WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+                  IF(lwp) THEN
+                     WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   icount = icount + 1
                ELSE
@@ -1273,12 +1290,15 @@
       !!----------------------------------------------------------------------
       !
-      IF (lwp) WRITE(numout,*) ' '
-      IF (lwp) WRITE(numout,*) 'bdy_ctl_seg: Check analytical segments'
-      IF (lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-      !
-      IF(lwp) WRITE(numout,*) 'Number of east  segments     : ', nbdysege
-      IF(lwp) WRITE(numout,*) 'Number of west  segments     : ', nbdysegw
-      IF(lwp) WRITE(numout,*) 'Number of north segments     : ', nbdysegn
-      IF(lwp) WRITE(numout,*) 'Number of south segments     : ', nbdysegs
+      IF (lwp) THEN
+         WRITE(numout,*) ' '
+         WRITE(numout,*) 'bdy_ctl_seg: Check analytical segments'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      !
+         WRITE(numout,*) 'Number of east  segments     : ', nbdysege
+         WRITE(numout,*) 'Number of west  segments     : ', nbdysegw
+         WRITE(numout,*) 'Number of north segments     : ', nbdysegn
+         WRITE(numout,*) 'Number of south segments     : ', nbdysegs
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       ! 1. Check bounds
       !----------------
@@ -1322,5 +1342,8 @@
       ! 2. Look for segment crossings
       !------------------------------ 
-      IF (lwp) WRITE(numout,*) '**Look for segments corners  :'
+      IF (lwp) THEN
+         WRITE(numout,*) '**Look for segments corners  :'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       itest = 0 ! corner number
@@ -1482,5 +1505,8 @@
             ELSE
                ! This is a corner
-               IF(lwp) WRITE(numout,*) 'Found a South-West corner at (i,j): ', jpiwob(ib), jpjwdt(ib)
+               IF(lwp) THEN
+                  WRITE(numout,*) 'Found a South-West corner at (i,j): ', jpiwob(ib), jpjwdt(ib)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                CALL bdy_ctl_corn(npckgw(ib), icornw(ib,1))
                itest=itest+1
@@ -1494,5 +1520,8 @@
             ELSE
                ! This is a corner
-               IF(lwp) WRITE(numout,*) 'Found a North-West corner at (i,j): ', jpiwob(ib), jpjwft(ib)
+               IF(lwp) THEN
+                  WRITE(numout,*) 'Found a North-West corner at (i,j): ', jpiwob(ib), jpjwft(ib)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                CALL bdy_ctl_corn(npckgw(ib), icornw(ib,2))
                itest=itest+1
@@ -1522,5 +1551,8 @@
             ELSE
                ! This is a corner
-               IF(lwp) WRITE(numout,*) 'Found a South-East corner at (i,j): ', jpieob(ib)+1, jpjedt(ib)
+               IF(lwp) THEN
+                  WRITE(numout,*) 'Found a South-East corner at (i,j): ', jpieob(ib)+1, jpjedt(ib)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                CALL bdy_ctl_corn(npckge(ib), icorne(ib,1))
                itest=itest+1
@@ -1534,5 +1566,8 @@
             ELSE
                ! This is a corner
-               IF(lwp) WRITE(numout,*) 'Found a North-East corner at (i,j): ', jpieob(ib)+1, jpjeft(ib)
+               IF(lwp) THEN
+                  WRITE(numout,*) 'Found a North-East corner at (i,j): ', jpieob(ib)+1, jpjeft(ib)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                CALL bdy_ctl_corn(npckge(ib), icorne(ib,2))
                itest=itest+1
@@ -1593,5 +1628,8 @@
       END DO
       !
-      IF ((itest==0).AND.(lwp)) WRITE(numout,*) 'NO open boundary corner found'
+      IF ((itest==0).AND.(lwp)) THEN
+         WRITE(numout,*) 'NO open boundary corner found'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       ! Other tests TBD: 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdytides.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdytides.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdytides.F90	(revision 10986)
@@ -82,8 +82,9 @@
       !!----------------------------------------------------------------------
       !
-      IF (nb_bdy>0) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'bdytide_init : initialization of tidal harmonic forcing at open boundaries'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+      IF (nb_bdy>0 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'bdytide_init : initialization of tidal harmonic forcing at open boundaries'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -107,16 +108,17 @@
             IF(lwm .AND. nprint > 2) WRITE ( numond, nambdy_tide )
             !                                               ! Parameter control and print
-            IF(lwp) WRITE(numout,*) '  '
-            IF(lwp) WRITE(numout,*) '          Namelist nambdy_tide : tidal harmonic forcing at open boundaries'
-            IF(lwp) WRITE(numout,*) '             read tidal data in 2d files: ', ln_bdytide_2ddta
-            IF(lwp) WRITE(numout,*) '             assume complex conjugate   : ', ln_bdytide_conj
-            IF(lwp) WRITE(numout,*) '             Number of tidal components to read: ', nb_harmo
-            IF(lwp) THEN 
-                    WRITE(numout,*) '             Tidal components: ' 
+            IF(lwp) THEN
+               WRITE(numout,*) '  '
+               WRITE(numout,*) '          Namelist nambdy_tide : tidal harmonic forcing at open boundaries'
+               WRITE(numout,*) '             read tidal data in 2d files: ', ln_bdytide_2ddta
+               WRITE(numout,*) '             assume complex conjugate   : ', ln_bdytide_conj
+               WRITE(numout,*) '             Number of tidal components to read: ', nb_harmo
+               WRITE(numout,*) '             Tidal components: ' 
                DO itide = 1, nb_harmo
                   WRITE(numout,*)  '                 ', Wave(ntide(itide))%cname_tide 
                END DO
+               WRITE(numout,*) ' '
+               IF(lflush) CALL FLUSH(numout)
             ENDIF 
-            IF(lwp) WRITE(numout,*) ' '
 
             ! Allocate space for tidal harmonics data - get size from OBC data arrays
@@ -312,4 +314,5 @@
            WRITE(numout,*) 'bdytide_update : (re)Initialization of the tidal bdy forcing at kt=',kt
            WRITE(numout,*) '~~~~~~~~~~~~~~ '
+           IF(lflush) CALL FLUSH(numout)
         ENDIF
         !
@@ -419,7 +422,8 @@
                !
                IF(lwp) THEN
-               WRITE(numout,*)
-               WRITE(numout,*) 'bdy_tide_dta : Refresh nodal factors for tidal open bdy data at kt=',kt
-               WRITE(numout,*) '~~~~~~~~~~~~~~ '
+                  WRITE(numout,*)
+                  WRITE(numout,*) 'bdy_tide_dta : Refresh nodal factors for tidal open bdy data at kt=',kt
+                  WRITE(numout,*) '~~~~~~~~~~~~~~ '
+                  IF(lflush) CALL FLUSH(numout)
                ENDIF
                !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyvol.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyvol.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/BDY/bdyvol.F90	(revision 10986)
@@ -163,11 +163,14 @@
 
 
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*)'bdy_vol : time step :', kt
-         IF(lwp) WRITE(numout,*)'~~~~~~~ '
-         IF(lwp) WRITE(numout,*)'          cumulate flux EMP             =', z_cflxemp  , ' (m3/s)'
-         IF(lwp) WRITE(numout,*)'          total lateral surface of OBC  =', bdysurftot, '(m2)'
-         IF(lwp) WRITE(numout,*)'          correction velocity zubtpecor =', zubtpecor , '(m/s)'
-         IF(lwp) WRITE(numout,*)'          cumulated transport ztranst   =', ztranst   , '(m3/s)'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*)'bdy_vol : time step :', kt
+            WRITE(numout,*)'~~~~~~~ '
+            WRITE(numout,*)'          cumulate flux EMP             =', z_cflxemp  , ' (m3/s)'
+            WRITE(numout,*)'          total lateral surface of OBC  =', bdysurftot, '(m2)'
+            WRITE(numout,*)'          correction velocity zubtpecor =', zubtpecor , '(m/s)'
+            WRITE(numout,*)'          cumulated transport ztranst   =', ztranst   , '(m3/s)'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       END IF 
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/c1d.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/c1d.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/c1d.F90	(revision 10986)
@@ -67,4 +67,5 @@
          WRITE(numout,*) '      column longitude                rn_lon1d     = ', rn_lon1d
          WRITE(numout,*) '      column localization in a grid   ln_c1d_locpt = ', ln_c1d_locpt
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dtauvd.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dtauvd.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dtauvd.F90	(revision 10986)
@@ -84,4 +84,5 @@
             WRITE(numout,*) '   U & V current data not used'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                             ! no initialization when restarting
@@ -155,4 +156,5 @@
             WRITE(numout,*)
             WRITE(numout,*) 'dta_uvd: interpolate U & V current data onto the s- or mixed s-z-coordinate mesh'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          !
@@ -210,5 +212,8 @@
       IF( .NOT. ln_uvd_dyndmp    ) THEN   !==   deallocate U & V current structure   ==! 
          !                                !==   (data used only for initialization)  ==!
-         IF(lwp) WRITE(numout,*) 'dta_uvd: deallocate U & V current arrays as they are only used to initialize the run'
+         IF(lwp) THEN
+            WRITE(numout,*) 'dta_uvd: deallocate U & V current arrays as they are only used to initialize the run'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
                                    DEALLOCATE( sf_uvd(1)%fnow )     ! U current arrays in the structure
          IF( sf_uvd(1)%ln_tint )   DEALLOCATE( sf_uvd(1)%fdta )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyncor_c1d.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyncor_c1d.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyncor_c1d.F90	(revision 10986)
@@ -48,7 +48,10 @@
       !!----------------------------------------------------------------------
 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'cor_c1d : Coriolis factor at T-point'
-      IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'cor_c1d : Coriolis factor at T-point'
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       !
@@ -68,8 +71,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_cor_c1d : total vorticity trend in 1D'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn_cor_c1d : total vorticity trend in 1D'
+         WRITE(numout,*) '~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyndmp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyndmp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/C1D/dyndmp.F90	(revision 10986)
@@ -98,4 +98,5 @@
          WRITE(numout,*) '      Damping file name               cn_resto  = ', cn_resto
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -112,4 +113,5 @@
             CALL ctl_stop(ctmp1)
          END SELECT
+         IF(lwp .AND. lflush) CALL FLUSH(numout)
          !
          IF( .NOT. ln_uvd_dyndmp ) THEN      ! force the initialization of U & V current data for damping
